
const { globalShortcut } = require('electron');
const  localShortcut  = require('electron-localshortcut');
const handel = {}

handel.addKeyEvent = (win, shortcutKeys, _screenshot) => {
  globalShortcut.unregisterAll();
  if (!shortcutKeys.open) return
  if (!shortcutKeys.screenshot) return
  //绑定快捷键 快捷显示或隐藏窗口
  globalShortcut.register(keyToTxt(shortcutKeys.open), () => {
    if (win.isVisible()) {
      win.hide();
    } else {
      win.show()
    }
  })
  //截图快捷键
  globalShortcut.register(keyToTxt(shortcutKeys.screenshot), () => {
    _screenshot()
  })
  // //苹果注册快捷复制粘贴
  // if (process.platform === "darwin") {
  //   let contents = win.webContents;
  //   localShortcut.register(win, "CommandOrControl+C", () => {
  //     contents.copy();
  //   });
  //   localShortcut.register(win, "CommandOrControl+V", () => {
  //     contents.paste();
  //   });
  // }
}
handel.addCopyKeyEvent = (win) => {
  // localShortcut.unregisterAll()
  //苹果注册快捷复制粘贴
  if (process.platform === "darwin") {
    let contents = win.webContents;
    localShortcut.register(win, "CommandOrControl+C", () => {
      contents.copy();
    });
    //粘贴
    localShortcut.register(win, "CommandOrControl+V", () => {
      contents.paste();
    });
    //剪切
    localShortcut.register(win, "CommandOrControl+X", () => {
      contents.cut();
    });
    //撤销
    localShortcut.register(win, "CommandOrControl+Z", () => {
      contents.undo();
    });
    //重做
    localShortcut.register(win, "Shift+CommandOrControl+Z", () => {
      contents.redo()
    });
    //全选
    localShortcut.register(win, "CommandOrControl+A", () => {
      contents.selectAll();
    });
  }
}
handel.removeKeyEvent = () => {
  globalShortcut.unregisterAll();
}

function keyToTxt(keyInfo) {
  let txt = ''
  if (keyInfo.ctrlKey) txt += 'Ctrl +'
  if (keyInfo.shiftKey) txt += 'Shift +'
  if (keyInfo.altKey) txt += 'Alt +'
  txt += getKeyCode(keyInfo.keyCode)
  return txt;
}

function getKeyCode(keyCode) {
  let keyName = null
  let letter = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.split('')
  for (let i = 0; i < letter.length; i++) {
    if (keyCode == i + 65) keyName = letter[i]
  }
  let number = '0123456789'.split('')
  for (let i = 0; i < number.length; i++) {
    if (keyCode == i + 48) keyName = number[i]
  }
  return keyName
}

module.exports = handel
